#include "exhibit.h"
#include "snode.h"
#include "scene.h"

ExSelection ExSelection::null;


// selection
ExSelection::ExSelection(Exhibit *ex)
{
	this->ex = ex;
	obj = data = 0;
	validmask = 0;
}

ExSelection::operator bool() const
{
	return ex != 0;
}

// Exhibit data
ExData::ExData()
{
	voice = 0;
}

ExData::~ExData()
{
	delete voice;
}

// exhibit class
Exhibit::Exhibit()
{
	orig_parent = 0;
	prev_slot = 0;
}

Exhibit::~Exhibit()
{
}

void Exhibit::set_node(SceneNode *node)
{
	this->node = node;
	orig_parent = node->get_parent();
}

ExSelection Exhibit::select(const Ray &ray) const
{
	ExSelection sel;
	HitPoint hit;
	if(get_aabox().intersect(ray, &hit)) {
		sel.ex = (Exhibit*)this;
		sel.selray = ray;
		sel.dist = hit.dist;
		sel.validmask = EXSEL_RAY;
	}
	return sel;
}

ExSelection Exhibit::select(const Sphere &sph) const
{
	return ExSelection(0);	// TODO
}

void Exhibit::update(float dt)
{
}

const AABox &Exhibit::get_aabox() const
{
	aabb = node->get_bounds();
	return aabb;
}
